package com.hand.hls.hlcm.acr.dto;

import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @Author Robert8900
 * @Date: 2018/8/24 16:20
 * @Description:发票行表dto
 * @Purpose:
 **/
@ExtensionAttribute(disable = true)
@Table(name = "acr_invoice_ln")
public class AcrInvoiceLn extends BaseDTO {
    @Id
    @GeneratedValue
    private Long invoiceLnId;  //发票行ID
    @NotNull
    private Long invoiceHdId; //发票ID
    private String lineType;  //行类型
    private Long lineNumber; //行号
    private Long cashflowId;  //现金流ID
    private Long cfItem;   //现金流项目
    private Long cfType;   //现金流类型
    private Long productId;  //商品ID
    private String productName;  //商品名称
    private String specification;  //规格型号
    private Double quantity;  //数量
    private String uom;  //计量单位
    private Double price;  //单价
    private Double priceQuantity;  //价格数量
    private String priceQuantityUom;  //价格数量单位
    private Double netPrice;  //税前单价
    private Long taxTypeId;  //税种
    private Double taxTypeRate;  //税率
    private String taxIncludedFlag;  //含税标志
    private Double taxAmount;  //税额
    private Double netAmount;  //税前金额
    private Double totalAmount;  //含税金额
    private Long responsibilityCenterId;  //责任中心
    private Long accountId;  //科目
    private String description;  //行备注/行摘要
    private String refV01;
    private String refV02;
    private String refV03;
    private String refV04;
    private String refV05;
    private String refV06;
    private String refV07;
    private String refV08;
    private String refV09;
    private String refV10;
    private Double refN01;
    private Double refN02;
    private Double refN03;
    private Double refN04;
    private Double refN05;
    private Double refN06;
    private Double refN07;
    private Double refN08;
    private Double refN09;
    private Double refN10;
    private Date refD01;
    private Date refD02;
    private Date refD03;
    private Date refD04;
    private Date refD05;
    private String leaseChannel;  //商业模式

    public Long getInvoiceLnId() {
        return invoiceLnId;
    }

    public void setInvoiceLnId(Long invoiceLnId) {
        this.invoiceLnId = invoiceLnId;
    }

    public Long getInvoiceHdId() {
        return invoiceHdId;
    }

    public void setInvoiceHdId(Long invoiceHdId) {
        this.invoiceHdId = invoiceHdId;
    }

    public String getLineType() {
        return lineType;
    }

    public void setLineType(String lineType) {
        this.lineType = lineType;
    }

    public Long getLineNumber() {
        return lineNumber;
    }

    public void setLineNumber(Long lineNumber) {
        this.lineNumber = lineNumber;
    }

    public Long getCashflowId() {
        return cashflowId;
    }

    public void setCashflowId(Long cashflowId) {
        this.cashflowId = cashflowId;
    }

    public Long getCfItem() {
        return cfItem;
    }

    public void setCfItem(Long cfItem) {
        this.cfItem = cfItem;
    }

    public Long getCfType() {
        return cfType;
    }

    public void setCfType(Long cfType) {
        this.cfType = cfType;
    }

    public Long getProductId() {
        return productId;
    }

    public void setProductId(Long productId) {
        this.productId = productId;
    }

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getSpecification() {
        return specification;
    }

    public void setSpecification(String specification) {
        this.specification = specification;
    }

    public Double getQuantity() {
        return quantity;
    }

    public void setQuantity(Double quantity) {
        this.quantity = quantity;
    }

    public String getUom() {
        return uom;
    }

    public void setUom(String uom) {
        this.uom = uom;
    }

    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    public Double getPriceQuantity() {
        return priceQuantity;
    }

    public void setPriceQuantity(Double priceQuantity) {
        this.priceQuantity = priceQuantity;
    }

    public String getPriceQuantityUom() {
        return priceQuantityUom;
    }

    public void setPriceQuantityUom(String priceQuantityUom) {
        this.priceQuantityUom = priceQuantityUom;
    }

    public Double getNetPrice() {
        return netPrice;
    }

    public void setNetPrice(Double netPrice) {
        this.netPrice = netPrice;
    }

    public Long getTaxTypeId() {
        return taxTypeId;
    }

    public void setTaxTypeId(Long taxTypeId) {
        this.taxTypeId = taxTypeId;
    }

    public Double getTaxTypeRate() {
        return taxTypeRate;
    }

    public void setTaxTypeRate(Double taxTypeRate) {
        this.taxTypeRate = taxTypeRate;
    }

    public String getTaxIncludedFlag() {
        return taxIncludedFlag;
    }

    public void setTaxIncludedFlag(String taxIncludedFlag) {
        this.taxIncludedFlag = taxIncludedFlag;
    }

    public Double getTaxAmount() {
        return taxAmount;
    }

    public void setTaxAmount(Double taxAmount) {
        this.taxAmount = taxAmount;
    }

    public Double getNetAmount() {
        return netAmount;
    }

    public void setNetAmount(Double netAmount) {
        this.netAmount = netAmount;
    }

    public Double getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(Double totalAmount) {
        this.totalAmount = totalAmount;
    }

    public Long getResponsibilityCenterId() {
        return responsibilityCenterId;
    }

    public void setResponsibilityCenterId(Long responsibilityCenterId) {
        this.responsibilityCenterId = responsibilityCenterId;
    }

    public Long getAccountId() {
        return accountId;
    }

    public void setAccountId(Long accountId) {
        this.accountId = accountId;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getRefV01() {
        return refV01;
    }

    public void setRefV01(String refV01) {
        this.refV01 = refV01;
    }

    public String getRefV02() {
        return refV02;
    }

    public void setRefV02(String refV02) {
        this.refV02 = refV02;
    }

    public String getRefV03() {
        return refV03;
    }

    public void setRefV03(String refV03) {
        this.refV03 = refV03;
    }

    public String getRefV04() {
        return refV04;
    }

    public void setRefV04(String refV04) {
        this.refV04 = refV04;
    }

    public String getRefV05() {
        return refV05;
    }

    public void setRefV05(String refV05) {
        this.refV05 = refV05;
    }

    public String getRefV06() {
        return refV06;
    }

    public void setRefV06(String refV06) {
        this.refV06 = refV06;
    }

    public String getRefV07() {
        return refV07;
    }

    public void setRefV07(String refV07) {
        this.refV07 = refV07;
    }

    public String getRefV08() {
        return refV08;
    }

    public void setRefV08(String refV08) {
        this.refV08 = refV08;
    }

    public String getRefV09() {
        return refV09;
    }

    public void setRefV09(String refV09) {
        this.refV09 = refV09;
    }

    public String getRefV10() {
        return refV10;
    }

    public void setRefV10(String refV10) {
        this.refV10 = refV10;
    }

    public Double getRefN01() {
        return refN01;
    }

    public void setRefN01(Double refN01) {
        this.refN01 = refN01;
    }

    public Double getRefN02() {
        return refN02;
    }

    public void setRefN02(Double refN02) {
        this.refN02 = refN02;
    }

    public Double getRefN03() {
        return refN03;
    }

    public void setRefN03(Double refN03) {
        this.refN03 = refN03;
    }

    public Double getRefN04() {
        return refN04;
    }

    public void setRefN04(Double refN04) {
        this.refN04 = refN04;
    }

    public Double getRefN05() {
        return refN05;
    }

    public void setRefN05(Double refN05) {
        this.refN05 = refN05;
    }

    public Double getRefN06() {
        return refN06;
    }

    public void setRefN06(Double refN06) {
        this.refN06 = refN06;
    }

    public Double getRefN07() {
        return refN07;
    }

    public void setRefN07(Double refN07) {
        this.refN07 = refN07;
    }

    public Double getRefN08() {
        return refN08;
    }

    public void setRefN08(Double refN08) {
        this.refN08 = refN08;
    }

    public Double getRefN09() {
        return refN09;
    }

    public void setRefN09(Double refN09) {
        this.refN09 = refN09;
    }

    public Double getRefN10() {
        return refN10;
    }

    public void setRefN10(Double refN10) {
        this.refN10 = refN10;
    }

    public Date getRefD01() {
        return refD01;
    }

    public void setRefD01(Date refD01) {
        this.refD01 = refD01;
    }

    public Date getRefD02() {
        return refD02;
    }

    public void setRefD02(Date refD02) {
        this.refD02 = refD02;
    }

    public Date getRefD03() {
        return refD03;
    }

    public void setRefD03(Date refD03) {
        this.refD03 = refD03;
    }

    public Date getRefD04() {
        return refD04;
    }

    public void setRefD04(Date refD04) {
        this.refD04 = refD04;
    }

    public Date getRefD05() {
        return refD05;
    }

    public void setRefD05(Date refD05) {
        this.refD05 = refD05;
    }

    public String getLeaseChannel() {
        return leaseChannel;
    }

    public void setLeaseChannel(String leaseChannel) {
        this.leaseChannel = leaseChannel;
    }
}
